#include "filestream.h"
#include "ui_form.h"

FileStream::FileStream(QWidget *parent)
    : QDialog(parent), ui(new Ui::FileStream)
{
    ui->setupUi(this);
}

FileStream::~FileStream()
{
    delete ui;
}

void FileStream::on_pushButton_3_released()
{
    QDialog::close();
}

void FileStream::on_open_released()
{
    QFileDialog::Options options;
    options |= QFileDialog::DontUseNativeDialog;
    QString selectedFilter;

    QString fileName = QFileDialog::getOpenFileName(this,
                   QString::fromUtf8("Otev\305\231\303\255t"), "",
                   tr("Text Files (*.fst)"), &selectedFilter, options);
    if (!fileName.isEmpty())
    {
        QFile file(fileName);
        if (!file.open(QFile::ReadOnly | QFile::Text)) {
             QMessageBox::warning(this, tr("FileStream"),
                                  QString::fromUtf8("Nemu otevt soubor %1:\n%2.")
                                  .arg(fileName)
                                  .arg(file.errorString()));
             return;
        }

        QTextStream in(&file);
        QApplication::setOverrideCursor(Qt::WaitCursor);
        QString str;
        in >> str;
        ui->textEdit->setText(str);
        QApplication::restoreOverrideCursor();
    }
}

void FileStream::on_save_released()
{
    QFileDialog::Options options;
    options |= QFileDialog::DontUseNativeDialog;
    QString selectedFilter;
    QString fileName = QFileDialog::getSaveFileName(this,
                   QString::fromUtf8("Uloit"), "",
                   tr("Text Files (*.fst)"), &selectedFilter, options);
    if (!fileName.isEmpty())
    {
        if (fileName.indexOf(".fst") == -1)
            fileName += ".fst";
        QFile file(fileName);
        if (!file.open(QFile::WriteOnly | QFile::Text)) {
             QMessageBox::warning(this, tr("FileStream"),
                                  QString::fromUtf8("Nemu zapisovat do souboru %1:\n%2.")
                                  .arg(fileName)
                                  .arg(file.errorString()));
             return;
        }

        QTextStream out(&file);
        QApplication::setOverrideCursor(Qt::WaitCursor);
        out << ui->textEdit->toPlainText();
        QApplication::restoreOverrideCursor();
    }
}
